#pragma once
#include "ActorInterface.h"
#include "wascommand.h"
#include "WASActor.h"

class CWASGetMessages :
	public CWASCommand
{
public:
	CWASGetMessages(CWASActor *pActor);
	~CWASGetMessages(void);

	void ExecuteAsync(void);

	void SetParameter(int nRoomId, int nJoinSeq, int nFromMsgNum, int nToMsgNum, int nSendSuccess)
	{
		m_nRoomId = nRoomId;
		m_nJoinSeq = nJoinSeq;
		//m_nLastMsgNum = nLastMsgNum;
        m_nFromMsgNum = nFromMsgNum;
        m_nToMsgNum = nToMsgNum;
		m_nSendSuccess = nSendSuccess;
	}

private:
	bool ParseAndEventFire(nfc::CIkXMLDom * pDom);

protected:
	// override in drived class
	virtual void OnWasResponse(trid_t /*trid*/, bool /*bSuccess*/, int /*nWinINetErrorCode*/, int /*nHttpResponseCode*/, 
		LPCSTR /*szWasResCodeInHeader*/, 
		LPCSTR /*szWasResCodeInXml*/,
		nfc::CIkXMLDom * /*pDom*/);

	virtual void OnRequestTimeout(CHttpFacade * /*pHttpF*/, DWORD /*dwSeconds*/);

private:
	std::vector<NE_MESSAGE_DATA> m_listMessage;

	int m_nRoomId;
	int m_nJoinSeq;
	//int m_nLastMsgNum;
    int m_nFromMsgNum;
    int m_nToMsgNum;
	int m_nSendSuccess;	// 1 == 'y' else 'y' or 'n'(all)
};
